// VfbExView.h : interface of the CVfbExView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_VFBEXVIEW_H__B643EC16_0D38_11D2_88FB_00A0C9050951__INCLUDED_)
#define AFX_VFBEXVIEW_H__B643EC16_0D38_11D2_88FB_00A0C9050951__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "DynamicVf.h"
#include "PalHook.h"

// ---- Forward Declarations ----
class CVfBldrDoc;
class CVfbExDoc;

// -------------------------------------------------------------------------
//
// -------------------------------------------------------------------------
class CVfbExView : public CScrollView
{
protected:
	DynamicVf		m_vForm;					// The VForm
 	CPalMsgHandler	m_palMsgHandler;

protected: // create from serialization only
	CVfbExView();
	DECLARE_DYNCREATE(CVfbExView)

// Attributes
public:
	CVfbExDoc* GetDocument();
	BOOL	LoadVfbFile(LPCTSTR lpszPathName);
	void	ResetPalette()	{ m_palMsgHandler.DoRealizePalette(TRUE); }
	void	SetScrollByVForm();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVfbExView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CVfbExView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CVfbExView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPrintscrnAll();
	afx_msg void OnPrintscrnSel();
	afx_msg void OnPrintscrnScreen();
	afx_msg void OnPrintrptAll();
	afx_msg void OnPrintrptSel();
	afx_msg void OnPrintrptScreen();
	afx_msg void OnPreviewscrnAll();
	afx_msg void OnPreviewscrnSel();
	afx_msg void OnPreviewscrnScreen();
	afx_msg void OnPreviewrptAll();
	afx_msg void OnPreviewrptSel();
	afx_msg void OnPreviewrptScreen();
	afx_msg void OnViewGridmode();
	afx_msg void OnUpdateViewGridmode(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in VfbExView.cpp
inline CVfbExDoc* CVfbExView::GetDocument()
   { return (CVfbExDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VFBEXVIEW_H__B643EC16_0D38_11D2_88FB_00A0C9050951__INCLUDED_)
