// -------------------------------------------------------------------------
// Copyright @ 1997 TCK Software, Incorporated
// All Rights Reserved
// -------------------------------------------------------------------------

#include "stdafx.h"
#include "FileVF.h"
#include "VfHexDoc.h"
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// -------------------------------------------------------------------------
// CFileVfHdr Constructor
// -------------------------------------------------------------------------
CFileVfHdr::CFileVfHdr()
{
	Height(25);
	m_chkHex.Init(this, ID_HEXHDR_CHKHEX, "Hex On", 5,5,70,20);

	AddCtl(&m_chkHex);
}

// -------------------------------------------------------------------------
// CFileVfRow Constructor
// -------------------------------------------------------------------------
CFileVfRow::CFileVfRow()
{
	m_lblRecNo.Init(this, ID_HEX_RECNO, "0", 5,5,60,20);
	m_hexRec.Init(this, ID_HEX_REC, "***", 63, 2, 200, 56);
	m_hexRec.LineHeight(19);
	m_hexRec.HexOn(FALSE);

	m_lblRecNo.UseInGrid(TRUE);
	m_hexRec.UseInGrid(TRUE);

	m_lblRecNo.GridCaption(_T("Recno"));
	m_hexRec.GridCaption(_T("Data"));

	AddCtl(&m_lblRecNo);
	AddCtl(&m_hexRec);
}

// -------------------------------------------------------------------------
// CFileVfRow Destructor
// -------------------------------------------------------------------------
CFileVfRow::~CFileVfRow()
{
}

// IMPLEMENT_DYNCREATE(CFileVF, VForm)

BEGIN_MESSAGE_MAP(CFileVF, VForm)
	//{{AFX_MSG_MAP(CFileVF)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// -------------------------------------------------------------------------
// CFileVF Constructor
// -------------------------------------------------------------------------
CFileVF::CFileVF()
{
	BOOL bTryGridMode=FALSE;	// Change to TRUE to compile as a grid

	RowHeight(22);
	RowWidth(100);
	UseRptForm(TRUE);			// Use report style printing
	m_bHexOn = FALSE;			// Start with Hex Off

	if(bTryGridMode)
	{
		GridRowHeight(22);
		GridStyle(VFGRID_FLAT);
		AllowRowSizing(TRUE);
		GridMode(TRUE);
		m_bHexOn = TRUE;
	}

	// ------------- Header and footer with Something in them --------
	CFileVfHdr *pHdr = new CFileVfHdr();
	SetHeader(pHdr, FALSE);
	
	// Use a Fixed Width Font
	Font(GetFonts()->GetOrAdd(_T("Courier"), 90));
}

// -------------------------------------------------------------------------
// CFileVF Destructor
// -------------------------------------------------------------------------
CFileVF::~CFileVF()
{
}

// -------------------------------------------------------------------------
// CFileVF Init
// -------------------------------------------------------------------------
void CFileVF::Init(CVfHexDoc *pDoc)
{
	m_pDoc = pDoc;
}

// -------------------------------------------------------------------------
// Function to create a CFileVfRow
// -------------------------------------------------------------------------
VRow* CFileVF::InitRow()
{
	CFileVfRow *pRow = new CFileVfRow();
	pRow->m_hexRec.HexOn(m_bHexOn);
	return(pRow); 
}

// -------------------------------------------------------------------------
// Called when a row needs to be put on the screen
// -------------------------------------------------------------------------
BOOL CFileVF::OnGetRow(VRow *pRow)
{
	CString s1;
	CFileVfRow *r = (CFileVfRow*) pRow;
	int nRecSize = m_pDoc->RecSize();
	long idx = r->RowId();

	if(!m_pDoc->ReadRecord(idx))
		return FALSE;
	
	s1.Format("%ld",idx+1);
	r->m_lblRecNo.Text(s1);
	r->m_hexRec.SetHexText(m_pDoc->RecData(), nRecSize);

	return TRUE;
}

// -------------------------------------------------------------------------
// Called when a button is clicked
// -------------------------------------------------------------------------
void CFileVF::OnClick(VRow *pRow, int nId)
{
	CString s1;
	CFileVfRow *r = (CFileVfRow*) pRow;

	switch(nId) 
	{
	case ID_HEXHDR_CHKHEX:
		CFileVfHdr *pHdr = (CFileVfHdr *)Header();
		m_bHexOn = pHdr->m_chkHex.Checked();
		RowHeight(m_bHexOn ? 60 : 22);
		FormRowHeight(m_bHexOn ? 60 : 22);

		// Reset VHexStatic hex setting
		CFileVfRow *pRow;
		pRow = (CFileVfRow *)m_pDtlRow;
		pRow->m_hexRec.HexOn(m_bHexOn);
		pRow = (CFileVfRow *)m_pTmpRow;
		pRow->m_hexRec.HexOn(m_bHexOn);

		ResetVertScroll(FALSE);			// This will use the new Row height
		// ResizeToParent();				// This will use the new Row height
		RefreshScreen(VFR_BOTH);		// This ensures we get redrawn
		break;
	}
}

// -------------------------------------------------------------------------
// Reset the width
// -------------------------------------------------------------------------
void CFileVF::ResetWidth(int nRecSize) 
{
	CFileVfRow *pRow;
	int nWidth;
	CSize mySize;
	CRect rect;
	CFont *pOldFont;
	CDC *pDC = GetDC();

	pOldFont = pDC->SelectObject(GetFont());					 // Set Custom Font
	mySize = pDC->GetOutputTextExtent("A", 1);				 // Length of 1 letter
	nWidth = (mySize.cx * (nRecSize+1));

	// Reset detail rows fields - adjust size
	pRow = (CFileVfRow *)m_pDtlRow;
	rect.SetRect(63, 2, nWidth + 67, 60);
	pRow->m_hexRec.Rect(rect);

	pRow = (CFileVfRow *)m_pTmpRow;
	rect.SetRect(63, 2, nWidth + 67, 60);
	pRow->m_hexRec.Rect(rect);

	if(pOldFont)	pDC->SelectObject(pOldFont);	// Reset orig Font
	ReleaseDC(pDC);

	RowWidth(nWidth + 70);
	ResetHorzScroll(TRUE);			// This will use the new Row height
	// ResizeToParent();
}


