// -------------------------------------------------------------------------
// Copyright @ 1997 TCK Software, Incorporated
// All Rights Reserved
// -------------------------------------------------------------------------

#ifndef __FILEVF_H__
#define __FILEVF_H__

#include "vForm.h"
#include "VCtl2.h"
#include "VfHexDoc.h"
#include "VHexStatic.h"

#define ID_HEXHDR_CHKHEX		201	

#define ID_HEX_RECNO			301
#define ID_HEX_REC				302

class CFileVF;

// -------------------------------------------------------------------------
// CFileVfHdr Class
// -------------------------------------------------------------------------
class CFileVfHdr : public VHeader
{
public:
	CFileVfHdr();
	virtual ~CFileVfHdr() {};

public:
	VCheckBox	m_chkHex;
};

// -------------------------------------------------------------------------
// CFileVfRow Class
// -------------------------------------------------------------------------
class CFileVfRow : public VRow
{
public:
	CFileVfRow();
	virtual ~CFileVfRow();

public:
	VStatic		m_lblRecNo;			// Record Number - label
	VHexStatic	m_hexRec;			// ASCII/Hex text control
};

// -------------------------------------------------------------------------
// CFileVF Class
// -------------------------------------------------------------------------
class CFileVF : public VForm
{
protected:
	CVfHexDoc *m_pDoc;			// Pointer to Document
	BOOL		m_bHexOn;		// Show Hex Info?

public:
	CFileVF();						// Constructor
	virtual ~CFileVF();				// Destructor
	void Init(CVfHexDoc *m_pDoc);	// Init Routine
	void ResetWidth(int nRecSize);

public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFileVF)
	public:
	protected:
	//}}AFX_VIRTUAL

protected:
	virtual VRow*	InitRow();

	// --- the following functions deal with the Data ---
	virtual	BOOL	OnGetRow(VRow *pRow);		// Puts row to screen
	virtual BOOL	OnSaveRow(VRow *pRow) { return FALSE; }
	virtual BOOL	OnAddRow(VRow *pRow) { return FALSE; }

	virtual void	OnClick(VRow *pRow, int nId);

// Generated message map functions
protected:
	//{{AFX_MSG(CFileVF)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif


